#include<iostream.h>
#include<math.h>
#include<conio.h>
#include<iomanip.h>



class integ   // 
{
        private:
                double a,b,h,k,d,eps,J;
                int n;
                        double integral(double z);
                        double funk(double x);
                        double ka();
                        double runge();
                        double tochn();
                        double teor();
                        double max(double h);
                        double tt();


        public:
                void input();     // 
                void output();    // 
                void chet();      // 

};

void integ::input()
{
cout<<"Vvedite predeli integrirovania:"<<endl;
cout<<"Vvedite a = ";
cin>>a;
cout<<"Vvedite b = ";
cin>>b;
cout<<"Vvedite predel razbiebia:"<<endl;
cout<<"Vvedite d = ";
cin>>d;
}

double integ::integral(double z)
{
double x1=a;
double x2=b;
double I;
double x=x1+z;
double sum=0;
double q=(x2-x1)/z;
for(int i=1;i<=q-1;i++)
{
sum+=funk(x);
x+=z;
}
I=z*((funk(x2)-funk(x1))/2+sum);
return I;
}

double integ::funk(double x)
{
double F;
F=pow(x,10);
return F;
}

double integ::ka()
{
double y1,y2,y3,y4;
y1=h/4; y2=h/2; y3=h/8; y4=h/4;
double K;
K=(integral(y1)-integral(y2))/(integral(y3)-integral(y4));
return K;
}

double integ::runge()
{
double R;
double y1,y2;
y1=h/2; y2=h;
R=(integral(y1)-integral(y2))/(pow(2,k)-1);
return R;
}

double integ::tochn()
{
double T;
T=tt()-integral(h);
return T;
}

double integ::max(double h)
{
double i;
double m1,m2,M;
for(i=a;i<b;i+=h)
{
m1=90*pow(i,8);
m2=90*pow(i+h,8);
if(m1>m2) M=m1;
else M=m2;
}
return M;
}

double integ::teor()
{
double T;
T=(b-a)*max(h)*pow(h,k)/12;
return T;
}

double integ::tt()
{
double w;
w=(b-a)/999999;
return integral(w);
}

void integ::chet()
{
k=2;
int q=1;
cout<<setw(5)<<"n"<<setw(13)<<"dK"<<setw(13)<<"dtochn"<<setw(13)<<"dRunge";
cout<<setw(13)<<"dteor"<<setw(13)<<"I"<<endl;
for(int i=1;i<d;q++)
{
n=i;
h=(b-a)/i;

                        if(i==1)
                        {cout<<setw(5)<<i<<setw(13)<<"-"<<setw(13)<<tochn()<<setw(13)<<"-";
                        cout<<setw(13)<<teor()<<setw(13)<<integral(h)<<endl;
                        }

                        if(i==2)
                        {cout<<setw(5)<<i<<setw(13)<<"-"<<setw(13)<<tochn()<<setw(13)<<runge();
                        cout<<setw(13)<<teor()<<setw(13)<<integral(h)<<endl;
                        }


                        if(i>2)
                        {

                        cout<<setw(5)<<i<<setw(13)<<ka()<<setw(13)<<tochn()<<setw(13)<<runge();
                        cout<<setw(13)<<teor()<<setw(13)<<integral(h)<<endl;
                        }
i=pow(2,q);
}
}

void main()
{
integ a;
a.input();
a.chet();
system("pause");
}
