#include<iostream.h>
#include<conio.h>
#include<math.h>
#include<windows.h>
#include<stdio.h>

void ru(char text[150])
{
char str[150];
CharToOem(text,str);
cout<<str;
}

double f(double x)
{
return sin(x);
}
double fp1(double x)
{
return cos(x);
}
double fp2(double x)
{
return -sin(x);
}

void out(double a[50][50],int n,int m)
{
for(int i=0;i<n-1;i++)
{
  cout<<"(";
  for(int j=0;j<m;j++)
  {
    printf("% 6.2f",a[j][i]);
    cout<<" ";
  }
  cout<<")\n";
}
}

void run(double u[50],int n,double h,double x0)
{
double b[50];
double c[50];
double d[50];

for(int i=0;i<n-1;i++)
{
  b[i]=(double)(f(x0+i*h+2*h)-f(x0+i*h+h))/h-(f(x0+i*h+h)-f(x0+i*h))/h;
}

u[0]=(double)f(x0)/2;
u[n-1]=(double)fp2(x0+n*h-1*h)/2;

double alpha,gamma,beta,nu;

alpha=gamma=(double)h/3;
beta=(double)4*h/3;

c[0]=0;
d[0]=(double)fp2(x0+n*h-1*h)/2;

for(int i=1;i<n-1;i++)
{
  c[i]=(double)(-gamma)/(alpha*c[i-1]+beta);
  d[i]=(double)(-alpha*d[i-1]+b[i])/(alpha*c[i-1]+beta);
}

for(int i=n-2;i>0;i--)
  u[i]=(double)c[i]*u[i+1]+d[i];
}


void main()
{
ru("***  ***\n");
ru(", , \n\n");
int n,k=0;
double a3[50][50];
double a2[50][50];
double a3h[50][50];
double u[50];
double x0;
double h;
double h1;
double S3,S3H,S2,FF,S3e=0,S3He=0,S2e=0;
ru(" - : ");
cin>>n;
ru("   : ");
cin>>x0;
ru("          : ");
cin>>h;
//
run(u,n,h,x0);
for(int i=0;i<n-1;i++)
  a3[0][i]=f(x0+i*h);
a3[2][0]=f(x0)/2;
a3[2][n-1]=f(x0+n*h)/2;
for(int i=1;i<n-1;i++)
  a3[2][i]=u[i];
for(int i=0;i<n-1;i++)
  a3[1][i]=(f(x0+i*h+h)-f(x0+i*h))/h-(a3[2][i+1]+a3[2][i])/3*h;
for(int i=0;i<n-1;i++)
  a3[3][i]=(a3[2][i+1]+a3[2][i])/3/h;
ru("\n  ( )\n");
out(a3,n,4);
//
for(int i=0;i<n-1;i++)
  a3h[0][i]=f(x0+i*h);
for(int i=0;i<n-1;i++)
  a3h[1][i]=fp1(x0+i*h);
for(int i=0;i<n-1;i++)
  a3h[2][i]=(f(x0+i*h+h)-f(x0+i*h))/h/h*3-(fp1(x0+i*h+h)+2*fp1(x0+i*h))/h;
for(int i=0;i<n-1;i++)
  a3h[3][i]=(f(x0+i*h+h)-f(x0+i*h))/h/h/h*(-2)+(fp1(x0+i*h+h)+fp1(x0+i*h))/h/h;
ru("  ( )\n");
out(a3h,n,4);
//
for(int i=0;i<n-1;i++)
  a2[0][i]=f(x0+i*h);
for(int i=1;i<n-1;i++)
  a2[1][i]=2*(f(x0+i*h+h)-f(x0+i*h))/h-a2[1][i-1];
a2[1][0]=fp1(x0);
for(int i=0;i<n-2;i++)
  a2[2][i]=(a2[1][i+1]-a2[1][i])/2*h;
a2[2][n-2]=(f(x0+n*h)-f(x0+n*h-h))/h/h-a2[1][n-1]/h;
ru("  ( )\n");
out(a2,n,3);
//
cout<<"\n";
for(double j=h/2;j<=x0+n*h;j+=h)
{
  for(int i=0;i<n-1;i++)
    if(j>=x0+i*h&&j<x0+i*h+h)
    {
    FF=f(j);
    S3=a3[0][i]+
       a3[1][i]*(j-i*h)+
       a3[2][i]*(j-i*h)*(j-i*h)+
       a3[3][i]*(j-i*h)*(j-i*h)*(j-i*h);
    S3H=a3h[0][i]+
        a3h[1][i]*(j-i*h)+
        a3h[2][i]*(j-i*h)*(j-i*h)+
        a3h[3][i]*(j-i*h)*(j-i*h)*(j-i*h);
    S2=a2[0][i]+
       a2[1][i]*(j-i*h)+
       a2[2][i]*(j-i*h)*(j-i*h);
    S3e+=fabs(FF-S3);
    S3He+=fabs(FF-S3H);
    S2e+=fabs(FF-S2);
    cout<<"F("<<j<<")="<<FF<<"\n"
    <<"S3("<<j<<")="<<S3<<"\n"
    <<"S3H("<<j<<")="<<S3H<<"\n"
    <<"S2("<<j<<")="<<S2<<"\n";
    ru(": \n");
    cout<<"S3="<<fabs(FF-S3)<<"\n"
    <<"S3H="<<fabs(FF-S3H)<<"\n"
    <<"S2="<<fabs(FF-S2)<<"\n\n";
    k++;
    break;
    }
}
S3e/=k;
S3He/=k;
S2e/=k;
ru(" : \n");
cout<<"S3e="<<S3e/k<<"\n"
    <<"S3He="<<S3He<<"\n"
    <<"S2e="<<S2e<<"\n";
getch();
}

